#include <bits/stdc++.h>
using namespace std;
int main()
{
    int n,c,q;
    cin>>n>>c>>q;
    string s;
    cin>>s;
    int cnt=0;
    for(int i=0;i<n;++i)cnt+=s[i]-'0';
    if(c==n)
    {
        while(q--)
        {
            int l,r;
            cin>>l>>r;
            --l;--r;
            for(int i=l;i<=r;++i)
            {
                int cur=s[i]-'0';
                cur^=1;
                s[i]='0'+cur;
                if(cur==0)--cnt;
                else ++cnt;
            }
            cout<<cnt<<endl;
        }
        return 0;
    }
    if(c==1)
    {
        while(q--)
        {
            int l,r;
            cin>>l>>r;
            --l;--r;
            for(int i=l;i<=r;++i)
            {
                int cur=s[i]-'0';
                cur^=1;
                s[i]='0'+cur;
            }
            int ans=0;
            for(int i=1;i<n;++i)
                if(s[i]=='0'&&s[i-1]=='1')++ans;
            if(s[n-1]=='1')++ans;
            cout<<ans<<endl;

        }
    }

}